//
//  GBAsyncQuicklookThumbnailer.h
//  GBBasicsKit
//
//  Created by Andreas Schwarz on 3/12/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <AASFilesystemTools/AASFilesystemTools.h>

@class GBAsyncQuicklookThumbnailer;
@class GBFileItem;

// Delegate must implement this method
@interface NSObject (GBAsyncQuicklookThumbnailerDelegate)
- (void)asynchronousThumbnailer:(GBAsyncQuicklookThumbnailer *)creator createdThumbnail:(CGImageRef)thumb forFile:(GBFileItem *)file nextInQueue:(GBFileItem *)nextFile;
@end



@interface GBAsyncQuicklookThumbnailer : NSObject <AASQueuedObjectOperationDelegateProtocol> {
	NSMutableArray *operations;
	
	id delegate;
	
    CGSize size;
	
	NSArray *runLoopModes;
	
	NSUInteger maxProcesses;

}

- (NSUInteger)countLeft;

- (void)addFilesToQueue:(NSArray *)files;

- (void)clearQueue;
- (void)cancel;


@property(assign) id delegate;
@property(copy) NSArray *runLoopModes;
@property(assign) CGSize size;

@end
