//
//  GBBatchItem.h
//  GBBasicsKit
//
//  Created by Andreas Schwarz on 10/28/09.
//  Copyright 2009 immaterial. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface GBBatchItem : NSObject {
	GBBatchItem *parent;
	id representedObject;
	
	NSUInteger itemIndex;
	NSUInteger itemOverallIndex;
	
	NSArrayController *childrenSortController;
	NSMutableArray *children;
	
	BOOL isContainer;
	BOOL isExpanded;
}

- (id)initWithRepresentedObject:(id)object;

@property(retain) id representedObject;
@property(readonly) NSString * identifier; // Subclass to return unique ID for each item (for example, a file path)
@property(readonly) NSString * parentIdentifier; // Subclass to return the unique ID for item's parent (for example, path to file's folder)

@property(readonly) NSArray *arrangedChildren;
@property(retain) NSMutableArray *children;
@property(retain) NSArrayController *childrenSortController;

@property(readonly) BOOL isLeaf;
@property(assign) BOOL isContainer;
@property(assign) BOOL isExpanded;

@property(assign) GBBatchItem *parent;
@property(assign) NSUInteger itemIndex;
@property(assign) NSUInteger itemOverallIndex;

- (void)updateSortDescriptors:(NSArray *)sortDescriptors;
- (void)setOverallIndex:(NSUInteger *)overallIndex andIndex:(NSUInteger *)index;
- (void)clearIndexes;
- (void)clearChildren;
- (void)allChildrenRecursive:(NSMutableArray *)allChildren;

@end
